require 'yaml'
require 'tty-prompt'
require 'erb'
require 'json'

# cli/helpers
require 'ios_analytics_cli/helpers/terminal'

# cli/interactors
require 'ios_analytics_cli/interactors/interactor'
require 'ios_analytics_cli/interactors/event'
require 'ios_analytics_cli/interactors/user_property'

# cli
require 'ios_analytics_cli/version'
require 'ios_analytics_cli/info'
require 'ios_analytics_cli/error_handler'

# cli/commands
require 'ios_analytics_cli/commands/command'
require 'ios_analytics_cli/commands/init'
require 'ios_analytics_cli/commands/generate'

# cli/io
require 'ios_analytics_cli/io/io'
require 'ios_analytics_cli/io/config'

# cli/serializers
require 'ios_analytics_cli/serializers/base'

require 'ios_analytics_cli/serializers/objc/analytics'
require 'ios_analytics_cli/serializers/objc/enums'
require 'ios_analytics_cli/serializers/objc/event'
require 'ios_analytics_cli/serializers/objc/logger'
require 'ios_analytics_cli/serializers/objc/objc'
require 'ios_analytics_cli/serializers/objc/screen'
require 'ios_analytics_cli/serializers/objc/user_property'

require 'ios_analytics_cli/serializers/swift/analytics'
require 'ios_analytics_cli/serializers/swift/event'
require 'ios_analytics_cli/serializers/swift/logger'
require 'ios_analytics_cli/serializers/swift/screen'
require 'ios_analytics_cli/serializers/swift/swift'
require 'ios_analytics_cli/serializers/swift/user_property'

# cli/templates
require 'ios_analytics_cli/templates/templates'

# Analytics represents base module to which
# all other modules are namespaced.
module Analytics
end
