require 'tty-prompt'

module Analytics
  module Interactor
    class Event
      def self.all_enum_properties(events)
        events
        .map { |event| event.dup }
        .reject { |event| event['properties'].nil? }
        .each do | event|
          event['properties'] = event['properties'].reject { |property| property['values'].nil? }
        end
      end

      def self.enum_properties_from_event(event)
        event_copy = event.dup
        return nil if event_copy['properties'].nil?

        event_copy['properties'] = event_copy['properties'].reject { |property| property['values'].nil? }
        event_copy
      end
    end
  end
end
