module Analytics
  module Serializer
    class Swift < Base
      class Screen
        def initialize(src)
          @src = src
        end

        def save(path)
          @file_name = 'AnalyticsScreen.swift'
          output_path = File.join(path, @file_name)
          File.write(output_path, render)
        end

        private

        def render
          ERB.new(template, nil, '-').result(binding)
        end

        def template
          <<~TEMPLATE
            <%= ERB.new(Analytics::Templates.tmpl_at('header.erb')).result(binding) %>

            import Foundation

            extension Analytics {

                struct Screen {

                    let name: String

                    private init(name: String) {
                        self.name = name
                    }
                }
            }

            // MARK: - Screens

            extension Analytics.Screen {
            <% @src["screens"].each do |screen| -%>

                /// <%= screen["description"] %>
                static var <%= screen["name"].camel_case -%>: Analytics.Screen {
                    return .init(name: "<%= screen["name"] -%>")
                }
            <% end -%>
            }
          TEMPLATE
        end
      end
    end
  end
end
